#ifndef Git_Push_GithubErrors_h
#define Git_Push_GithubErrors_h

static NSString *GITHUB_ERROR_DOMAIN = @"com.adamstegman.Github";
static NSString *GITHUB_STRINGS_TABLE = @"Github";

/**
 * Error codes for the Github framework.
 */
enum {
  /* user errors */
  GHNoRepositoryError = 0, // a repository is needed to perform the operation
  GHNoCredentialsError = 1, // credentials are needed to perform the operation
  GHNoShaError = 2, // a sha is needed to perform the operation

  /* connection errors */
  GHConnectionNotModifiedError = 100, // the resource was not modified
  GHConnectionUnauthorizedError = 101, // the request was not authorized to view the resource
  GHConnectionForbiddenError = 102, // the request was forbidden to view the resource
  GHConnectionNotFoundError = 103, // the resource was not found
  GHConnectionUnknownError = 104 // an unknown error was encountered
};

#endif
