#import "GHAbstractResource.h"
#import "GHCommit.h"

@interface GHRef : GHAbstractResource {
  GHCommit *_object;
  NSString *_ref;
}

# pragma mark - Attributes

@property (nonatomic, readonly, strong) GHCommit *object; // TODO: what else could this be besides a commit?
@property (nonatomic, readonly, copy) NSString *ref;

# pragma mark - Initializers

/**
 * Creates a ref with the bare minimum properties to fetch its data from Github.
 *
 * TODO: The request to fetch the properties will be authenticated with the given credentials. If the repository is open
 * source, the credentials are not necessary.
 *
 * \param repository the Github repository that owns this ref
 * \param ref the reference designation, e.g. @"refs/heads/master"
 * \return a new GHRef without other properties
 */
- (id)initWithRepository:(GHRepository *)repository ref:(NSString *)ref;

/**
 * Creates a ref with the given properties.
 *
 * TODO: The request to fetch the properties will be authenticated with the given credentials. If the repository is open
 * source, the credentials are not necessary.
 *
 * \param repository the Github repository that owns this ref
 * \param ref the reference designation, e.g. @"refs/heads/master"
 * \param object the object pointed to by this ref
 * \return a new GHRef without other properties
 */
- (id)initWithRepository:(GHRepository *)repository ref:(NSString *)ref object:(GHCommit *)object;

@end
