#import "GithubTests.h"
#import "GHGitObject.h"

@interface GHGitObjectTests : GithubTests {
  GHGitObject *gitObject;
}

# pragma mark - Attributes

/** sha tests */

/**
 * Should have a readable NSString attribute called sha.
 */
- (void)testSha_NSString;

/**
 * Should not allow writes to sha.
 */
- (void)testSetSha_NoMethod;

# pragma mark - Github interaction

/** fetchDataWithParameters tests */

/**
 * Should notify delegate of failure if the repository attribute is missing.
 */
- (void)testFetchDataWithParameters_NilRepository_Failure;

/**
 * Should notify delegate of failure if the sha attribute is missing.
 */
- (void)testFetchDataWithParameters_NilSha_Failure;

/**
 * Should call fetchDataWithParameters: on the superclass if a repository and a sha exist.
 */
- (void)testFetchDataWithParameters_RepositorySha_Super;

@end
