#import "GithubTests.h"
#import "GHOrganization.h"

@interface GHOrganizationTests : GithubTests {
  GHOrganization *organization;
}

# pragma mark - Attributes

/** avatarURL tests */

/**
 * Should have a string property called avatarURL.
 */
- (void)testAvatarURL_NSString;

/**
 * Should not allow writes to avatarURL.
 */
- (void)testSetAvatarURL_NoMethod;

/** billingEmail tests */

/**
 * Should have a string property called billingEmail.
 */
- (void)testBillingEmail_NSString;

/**
 * Should not allow writes to billingEmail.
 */
- (void)testSetBillingEmail_NoMethod;

/** blog tests */

/**
 * Should have a string property called blog.
 */
- (void)testBlog_NSString;

/**
 * Should not allow writes to blog.
 */
- (void)testSetBlog_NoMethod;

/** collaboratorCount tests */

/**
 * Should have an unsigned integer property called collaboratorCount.
 */
- (void)testCollaboratorCount_NSUInteger;

/**
 * Should not allow writes to collaboratorCount.
 */
- (void)testSetCollaboratorCount_NoMethod;

/** company tests */

/**
 * Should have a string property called company.
 */
- (void)testCompany_NSString;

/**
 * Should not allow writes to company.
 */
- (void)testSetCompany_NoMethod;

/** createdAt tests */

/**
 * Should have a date property called createdAt.
 */
- (void)testCreatedAt_NSDate;

/**
 * Should not allow writes to createdAt.
 */
- (void)testSetCreatedAt_NoMethod;

/** diskUsage tests */

/**
 * Should have an unsigned integer property called diskUsage.
 */
- (void)testDiskUsage_NSUInteger;

/**
 * Should not allow writes to diskUsage.
 */
- (void)testSetDiskUsage_NoMethod;

/** email tests */

/**
 * Should have a string property called email.
 */
- (void)testEmail_NSString;

/**
 * Should not allow writes to email.
 */
- (void)testSetEmail_NoMethod;

/** followerCount tests */

/**
 * Should have an unsigned integer property called followerCount.
 */
- (void)testFollowerCount_NSUInteger;

/**
 * Should not allow writes to followerCount.
 */
- (void)testSetFollowerCount_NoMethod;

/** followingCount tests */

/**
 * Should have an unsigned integer property called followingCount.
 */
- (void)testFollowingCount_NSUInteger;

/**
 * Should not allow writes to followingCount.
 */
- (void)testSetFollowingCount_NoMethod;

/** githubURL tests */

/**
 * Should have a string property called githubURL.
 */
- (void)testGithubURL_NSString;

/**
 * Should not allow writes to githubURL.
 */
- (void)testSetGithubURL_NoMethod;

/** location tests */

/**
 * Should have a string property called location.
 */
- (void)testLocation_NSString;

/**
 * Should not allow writes to location.
 */
- (void)testSetLocation_NoMethod;

/** login tests */

/**
 * Should have a string property called login.
 */
- (void)testLogin_NSString;

/**
 * Should not allow writes to login.
 */
- (void)testSetLogin_NoMethod;

/** name tests */

/**
 * Should have a string property called name.
 */
- (void)testName_NSString;

/**
 * Should not allow writes to name.
 */
- (void)testSetName_NoMethod;

/** ownedRepositoryCount tests */

/**
 * Should have an unsigned integer property called ownedRepositoryCount.
 */
- (void)testOwnedRepositoryCount_NSUInteger;

/**
 * Should not allow writes to ownedRepositoryCount.
 */
- (void)testSetOwnedRepositoryCount_NoMethod;

/** plan tests */

/**
 * Should have a dictionary property called plan.
 */
- (void)testPlan_NSDictionary;

/**
 * Should not allow writes to plan.
 */
- (void)testSetPlan_NoMethod;

/** privateGistCount tests */

/**
 * Should have an unsigned integer property called privateGistCount.
 */
- (void)testPrivateGistCount_NSUInteger;

/**
 * Should not allow writes to privateGistCount.
 */
- (void)testSetPrivateGistCount_NoMethod;

/** privateRepositoryCount tests */

/**
 * Should have an unsigned integer property called privateRepositoryCount.
 */
- (void)testPrivateRepositoryCount_NSUInteger;

/**
 * Should not allow writes to privateRepositoryCount.
 */
- (void)testSetPrivateRepositoryCount_NoMethod;

/** publicGistCount tests */

/**
 * Should have an unsigned integer property called publicGistCount.
 */
- (void)testPublicGistCount_NSUInteger;

/**
 * Should not allow writes to publicGistCount.
 */
- (void)testSetPublicGistCount_NoMethod;

/** publicRepositoryCount tests */

/**
 * Should have an unsigned integer property called publicRepositoryCount.
 */
- (void)testPublicRepositoryCount_NSUInteger;

/**
 * Should not allow writes to publicRepositoryCount.
 */
- (void)testSetPublicRepositoryCount_NoMethod;

# pragma mark - Github API attributes names

/** avatar_url tests */

/**
 * Should have a string property called avatar_url linked to avatarURL.
 */
- (void)testAvatar_url_NSString;

/**
 * Should not allow writes to avatar_url.
 */
- (void)testSetAvatar_url_NoMethod;

/** billing_email tests */

/**
 * Should have a string property called billing_email.
 */
- (void)testBilling_email_NSString;

/**
 * Should not allow writes to billing_email.
 */
- (void)testSetBilling_email_NoMethod;

/** collaborators tests */

/**
 * Should have an unsigned integer property called collaborators linked to collaboratorCount.
 */
- (void)testCollaborators_NSUInteger;

/**
 * Should not allow writes to collaborators.
 */
- (void)testSetCollaborators_NoMethod;

/** created_at tests */

/**
 * Should have a date property called created_at linked to createdAt.
 */
- (void)testCreated_at_NSDate;

/**
 * Should not allow writes to created_at.
 */
- (void)testSetCreated_at_NoMethod;

/** disk_usage tests */

/**
 * Should have an unsigned integer property called disk_usage linked to diskUsage.
 */
- (void)testDisk_usage_NSUInteger;

/**
 * Should not allow writes to disk_usage.
 */
- (void)testSetDisk_usage_NoMethod;

/** followers tests */

/**
 * Should have an unsigned integer property called followers linked to followerCount.
 */
- (void)testFollowers_NSUInteger;

/**
 * Should not allow writes to followers.
 */
- (void)testSetFollowers_NoMethod;

/** following tests */

/**
 * Should have an unsigned integer property called following linked to followingCount.
 */
- (void)testFollowing_NSUInteger;

/**
 * Should not allow writes to following.
 */
- (void)testSetFollowing_NoMethod;

/** html_url tests */

/**
 * Should have a string property called html_url linked to githubURL.
 */
- (void)testHtml_url_NSString;

/**
 * Should not allow writes to githubURL.
 */
- (void)testSetHtml_url_NoMethod;

/** owned_private_repos tests */

/**
 * Should have an unsigned integer property called owned_private_repos linked to ownedRepositoryCount.
 */
- (void)testOwned_private_repos_NSUInteger;

/**
 * Should not allow writes to owned_private_repos.
 */
- (void)testSetOwned_private_repos_NoMethod;

/** private_gists tests */

/**
 * Should have an unsigned integer property called private_gists linked to privateGistCount.
 */
- (void)testPrivate_gists_NSUInteger;

/**
 * Should not allow writes to private_gists.
 */
- (void)testSetPrivate_gists_NoMethod;

/** public_gists tests */

/**
 * Should have an unsigned integer property called public_gists linked to publicGistCount.
 */
- (void)testPublic_gists_NSUInteger;

/**
 * Should not allow writes to public_gists.
 */
- (void)testSetPublic_gists_NoMethod;

/** public_repos tests */

/**
 * Should have an unsigned integer property called public_repos linked to publicRepositoryCount.
 */
- (void)testPublic_repos_NSUInteger;

/**
 * Should not allow writes to public_repos.
 */
- (void)testSetPublic_repos_NoMethod;

/** total_private_repos tests */

/**
 * Should have an unsigned integer property called total_private_repos linked to privateRepositoryCount.
 */
- (void)testTotal_private_repos_NSUInteger;

/**
 * Should not allow writes to total_private_repos.
 */
- (void)testSetTotal_private_repos_NoMethod;

# pragma mark - Initializers

/** initWithLogin: tests */

/**
 * Should create an organization with nil attributes given a nil login.
 */
- (void)testInitWithLogin_NilLogin_NilAttributes;

/**
 * Should store the given login.
 */
- (void)testInitWithLogin_Login_StoredLogin;

/** initWithAttributes: tests */

/**
 * Should create an organization with nil attributes given a nil attribute dictionary.
 */
- (void)testInitWithAttributes_Nil_NilAttributes;

/**
 * Should create an organization with nil attributes given an empty dictionary.
 */
- (void)testInitWithAttributes_Empty_NilAttributes;

/**
 * Should create an organization with the given attributes, and no extras.
 */
- (void)testInitWithAttributes_Attributes_StoredAttributes;

/**
 * Should create an organization with the given Github API returned attributes, and no extras.
 */
- (void)testInitWithAttributes_GithubAPIAttributes_StoredAttributes;

/**
 * Should create an organization with the given NSNull Github API returned attributes.
 */
- (void)testInitWithAttributes_GithubAPINullAttributes_StoredAttributes;

# pragma mark - Github interaction

/** apiPath tests */

/**
 * Should return the public organization path with this organization's login.
 */
- (void)testApiPath_PublicOrganizationPath;

/** fetchRepositories tests */

/**
 * Should call fetchDataAtApiPath:withParameters: at the organization's repository listing path.
 */
- (void)testFetchRepositories_FetchDataAtApiPathWithNoParameters;

# pragma mark - SBJsonStreamParserAdapter delegate methods

/** parser:foundArray: tests */

/**
 * Should not notify the delegate if the array is nil.
 */
- (void)testParserFoundArray_Nil_UnnotifiedDelegate;

/**
 * Should not notify the delegate if the array is empty.
 */
- (void)testParserFoundArray_Empty_UnnotifiedDelegate;

/**
 * Should notify the delegate of each discovered repository.
 */
- (void)testParserFoundArray_Repositories_NotifiedDelegate;

/** parser:foundObject: tests */

/**
 * Should not store anything given nil.
 */
- (void)testParserFoundObject_Nil_UnchangedAttributes;

/**
 * Should not store anything given an object with the wrong keys.
 */
- (void)testParserFoundObject_DifferentKeys_UnchangedAttributes;

/**
 * Should store data correctly.
 */
- (void)testParserFoundObject_Organization_CorrectAttributes;

/**
 * Should overwrite the existing data with the data found in the object.
 */
- (void)testParserFoundObject_ExistingData_UpdatedAttributes;

/**
 * Should store NSNull data correctly.
 */
- (void)testParserFoundObject_OrganizationWithNSNullAttributes_CorrectAttributes;

@end
