#import "GithubTests.h"
#import "GHRef.h"

@interface GHRefTests : GithubTests {
  GHRef *ref;
}

# pragma mark - Attributes

/** object tests */

/**
 * Should have a commit property called object.
 */
- (void)testObject_GHCommit;

/**
 * Should not allow writes to object.
 */
- (void)testSetObject_NoMethod;

/** ref tests */

/**
 * Should have a string property called ref.
 */
- (void)testRef_NSString;

/**
 * Should not allow writes to ref.
 */
- (void)testSetRef_NoMethod;

# pragma mark - Initializers

/** initWithRepository:ref: tests */

/**
 * Should create a ref with nil attributes if nil attributes are given.
 */
- (void)testInitWithRepositoryRef_NilAttributes_NewRefWithNilAttributes;

/**
 * Should create a ref with the given attributes and nil other attributes.
 */
- (void)testInitWithRepositoryRef_Attributes_NewRefWithCorrectAttributes;

/** initWithRepository:ref:object: tests */

/**
 * Should create a ref with nil attributes if nil attributes are given.
 */
- (void)testInitWithRepositoryRefObject_NilAttributes_NewRefWithNilAttributes;

/**
 * Should create a ref with the given attributes.
 */
- (void)testInitWithRepositoryRefObject_Attributes_NewRefWithCorrectAttributes;

# pragma mark - Github interaction

/** apiPath tests */

/**
 * Should return the path to this ref.
 */
- (void)testApiPath_RefPath;

# pragma mark - SBJsonStreamParser delegate methods

/** parser:foundObject: tests */

/**
 * Should not store anything given nil.
 */
- (void)testParserFoundObject_Nil_UnchangedAttributes;

/**
 * Should not store anything given an object with the wrong keys.
 */
- (void)testParserFoundObject_DifferentKeys_UnchangedAttributes;

/**
 * Should store data correctly.
 */
- (void)testParserFoundObject_Ref_CorrectAttributes;

/**
 * Should overwrite the existing data with the data found in the object.
 */
- (void)testParserFoundObject_ExistingData_UpdatedAttributes;

/**
 * Should store NSNull data correctly.
 */
- (void)testParserFoundObject_RefWithNSNullAttributes_CorrectAttributes;

@end
