#import "GithubTests.h"
#import "GHRepository.h"

@interface GHRepositoryTests : GithubTests {
  GHRepository *repository;
}

# pragma mark - Attributes

/** cloneURL tests */

/**
 * Should have a string property called cloneURL.
 */
- (void)testCloneURL_NSString;

/**
 * Should not allow writes to cloneURL.
 */
- (void)testSetCloneURL_NoMethod;

/** createdAt tests */

/**
 * Should have a date property called createdAt.
 */
- (void)testCreatedAt_NSDate;

/**
 * Should not allow writes to createdAt.
 */
- (void)testSetCreatedAt_NoMethod;

/** description tests */

/**
 * Should have a string property called description linked to cloneURL.
 */
- (void)testDescription_NSString;

/**
 * Should not allow writes to description.
 */
- (void)testSetDescription_NoMethod;

/** fork tests */

/**
 * Should have a boolean property called fork.
 */
- (void)testFork_Bool;

/**
 * Should not allow writes to fork.
 */
- (void)testSetFork_NoMethod;

/** forkCount tests */

/**
 * Should have an unsigned integer property called forkCount.
 */
- (void)testForkCount_NSUInteger;

/**
 * Should not allow writes to forkCount.
 */
- (void)testSetForkCount_NoMethod;

/** githubURL tests */

/**
 * Should have a string property called githubURL.
 */
- (void)testGithubURL_NSString;

/**
 * Should not allow writes to githubURL.
 */
- (void)testSetGithubURL_NoMethod;

/** gitURL tests */

/**
 * Should have a string property called gitURL.
 */
- (void)testGitURL_NSString;

/**
 * Should not allow writes to gitURL.
 */
- (void)testSetGitURL_NoMethod;

/** hasDownloads tests */

/**
 * Should have a boolean property called hasDownloads.
 */
- (void)testHasDownloads_Bool;

/**
 * Should not allow writes to hasDownloads.
 */
- (void)testSetHasDownloads_NoMethod;

/** hasIssues tests */

/**
 * Should have a boolean property called hasIssues.
 */
- (void)testHasIssues_Bool;

/**
 * Should not allow writes to hasIssues.
 */
- (void)testSetHasIssues_NoMethod;

/** hasWiki tests */

/**
 * Should have a boolean property called hasWiki.
 */
- (void)testHasWiki_Bool;

/**
 * Should not allow writes to hasWiki.
 */
- (void)testSetHasWiki_NoMethod;

/** language tests */

/**
 * Should have a string property called language linked to htmlURL.
 */
- (void)testLanguage_NSString;

/**
 * Should not allow writes to language.
 */
- (void)testSetLanguage_NoMethod;

/** masterBranch tests */

/**
 * Should have a string property called masterBranch.
 */
- (void)testMasterBranch_NSString;

/**
 * Should not allow writes to masterBranch.
 */
- (void)testSetMasterBranch_NoMethod;

/** name tests */

/**
 * Should have a string property called name linked to masterBranch.
 */
- (void)testName_NSString;

/**
 * Should not allow writes to name.
 */
- (void)testSetName_NoMethod;

/** openIssueCount tests */

/**
 * Should have an unsigned integer property called openIssueCount.
 */
- (void)testOpenIssueCount_NSUInteger;

/**
 * Should not allow writes to openIssueCount.
 */
- (void)testSetOpenIssueCount_NoMethod;

/** organization tests */

/**
 * Should have an organization property called organization.
 */
- (void)testOrganization_GHOrganization;

/**
 * Should not allow writes to organization.
 */
- (void)testSetOrganization_NoMethod;

/** owner tests */

/**
 * Should have a user property called owner.
 */
- (void)testOwner_GHUser;

/**
 * Should not allow writes to owner.
 */
- (void)testSetOwner_NoMethod;

/** parent tests */

/**
 * Should have a repository property called parent.
 */
- (void)testParent_GHRepository;

/**
 * Should not allow writes to parent.
 */
- (void)testSetParent_NoMethod;

/** private tests */

/**
 * Should have a boolean property called private.
 */
- (void)testPrivate_Bool;

/**
 * Should not allow writes to private.
 */
- (void)testSetPrivate_NoMethod;

/** pushedAt tests */

/**
 * Should have a date property called pushedAt.
 */
- (void)testPushedAt_NSDate;

/**
 * Should not allow writes to pushedAt.
 */
- (void)testSetPushedAt_NoMethod;

/** size tests */

/**
 * Should have an unsigned integer property called size linked to openIssueCount.
 */
- (void)testSize_NSUInteger;

/**
 * Should not allow writes to size.
 */
- (void)testSetSize_NoMethod;

/** source tests */

/**
 * Should have a repository property called source.
 */
- (void)testSource_GHRepository;

/**
 * Should not allow writes to source.
 */
- (void)testSetSource_NoMethod;

/** sshURL tests */

/**
 * Should have a string property called sshURL.
 */
- (void)testSshURL_NSString;

/**
 * Should not allow writes to sshURL.
 */
- (void)testSetSshURL_NoMethod;

/** svnURL tests */

/**
 * Should have a string property called svnURL.
 */
- (void)testSvnURL_NSString;

/**
 * Should not allow writes to svnURL.
 */
- (void)testSetSvnURL_NoMethod;

/** watcherCount tests */

/**
 * Should have an unsigned integer property called watcherCount.
 */
- (void)testWatcherCount_NSUInteger;

/**
 * Should not allow writes to watcherCount.
 */
- (void)testSetWatcherCount_NoMethod;

# pragma mark - Github API attribute names

/** clone_url tests */

/**
 * Should have a string property called clone_url linked to cloneURL.
 */
- (void)testClone_url_NSString;

/**
 * Should not allow writes to clone_url.
 */
- (void)testSetClone_url_NoMethod;

/** created_at tests */

/**
 * Should have a date property called created_at linked to createdAt.
 */
- (void)testCreated_at_NSDate;

/**
 * Should not allow writes to created_at.
 */
- (void)testSetCreated_at_NoMethod;

/** forks tests */

/**
 * Should have an unsigned integer property called forks linked to forkCount.
 */
- (void)testForks_NSUInteger;

/**
 * Should not allow writes to forks.
 */
- (void)testSetForks_NoMethod;

/** git_url tests */

/**
 * Should have a string property called git_url linked to gitURL.
 */
- (void)testGit_url_NSString;

/**
 * Should not allow writes to git_url.
 */
- (void)testSetGit_url_NoMethod;

/** has_downloads tests */

/**
 * Should have a boolean property called has_downloads.
 */
- (void)testHas_downloads_Bool;

/**
 * Should not allow writes to has_downloads.
 */
- (void)testSetHas_downloads_NoMethod;

/** has_issues tests */

/**
 * Should have a boolean property called has_issues.
 */
- (void)testHas_issues_Bool;

/**
 * Should not allow writes to has_issues.
 */
- (void)testSetHas_issues_NoMethod;

/** has_wiki tests */

/**
 * Should have a boolean property called has_wiki.
 */
- (void)testHas_wiki_Bool;

/**
 * Should not allow writes to has_wiki.
 */
- (void)testSetHas_wiki_NoMethod;

/** html_url tests */

/**
 * Should have a string property called html_url linked to htmlURL.
 */
- (void)testHtml_url_NSString;

/**
 * Should not allow writes to html_url.
 */
- (void)testSetHtml_url_NoMethod;

/** master_branch tests */

/**
 * Should have a string property called master_branch linked to masterBranch.
 */
- (void)testMaster_branch_NSString;

/**
 * Should not allow writes to master_branch.
 */
- (void)testSetMaster_branch_NoMethod;

/** open_issues tests */

/**
 * Should have an unsigned integer property called open_issues linked to openIssueCount.
 */
- (void)testOpen_issues_NSUInteger;

/**
 * Should not allow writes to open_issues.
 */
- (void)testSetOpen_issues_NoMethod;

/** pushed_at tests */

/**
 * Should have a date property called pushed_at linked to pushedAt.
 */
- (void)testPushed_at_NSDate;

/**
 * Should not allow writes to pushed_at.
 */
- (void)testSetPushed_at_NoMethod;

/** ssh_url tests */

/**
 * Should have a string property called ssh_url linked to sshURL.
 */
- (void)testSsh_url_NSString;

/**
 * Should not allow writes to ssh_url.
 */
- (void)testSetSsh_url_NoMethod;

/** svn_url tests */

/**
 * Should have a string property called svn_url linked to svnURL.
 */
- (void)testSvn_url_NSString;

/**
 * Should not allow writes to svn_url.
 */
- (void)testSetSvn_url_NoMethod;

/** watchers tests */

/**
 * Should have an unsigned integer property called watchers linked to watcherCount.
 */
- (void)testWatchers_NSUInteger;

/**
 * Should not allow writes to watchers.
 */
- (void)testSetWatchers_NoMethod;

# pragma mark - Initializers

/** initWithOwner:name: tests */

/**
 * Should create a repository with nil attributes given nil attributes.
 */
- (void)testInitWithOwnerName_NilAttributes_NilAttributes;

/**
 * Should store the given owner login and name.
 */
- (void)testInitWithOwnerName_LoginAndName_StoredLoginAndName;

/** initWithAttributes: tests */

/**
 * Should create a repository with nil attributes given a nil attribute dictionary.
 */
- (void)testInitWithAttributes_Nil_NilAttributes;

/**
 * Should create a repository with nil attributes given an empty dictionary.
 */
- (void)testInitWithAttributes_Empty_NilAttributes;

/**
 * Should create a repository with the given attributes, and no extras.
 */
- (void)testInitWithAttributes_Attributes_StoredAttributes;

/**
 * Should create a repository with the given Github API returned attributes, and no extras.
 */
- (void)testInitWithAttributes_GithubAPIAttributes_StoredAttributes;

/**
 * Should create a repository with the given NSNull Github API returned attributes.
 */
- (void)testInitWithAttributes_GithubAPINullAttributes_StoredAttributes;

# pragma mark - Github interaction

/** apiPath tests */

/**
 * Should return the public repository path with this repository's owner and name.
 */
- (void)testApiPath_PublicRepositoryPath;

/** fetchMasterHeadRef: tests */

/**
 * Should call fetchRef: at the path for the heads/master ref if no master branch is specified.
 */
- (void)testFetchMasterHeadRef_NoMasterBranch_FetchHeadsMasterRef;

/**
 * Should call fetchRef: at the path for the master branch HEAD ref.
 */
- (void)testFetchMasterHeadRef_MasterBranch_FetchMasterBranchHeadRef;

/** fetchRef: tests */

/**
 * Should call fetchApiPath:withParameters: at the path for the given ref.
 */
- (void)testFetchRef_Ref_FetchDataAtRefPathWithNoParameters;

# pragma mark - SBJsonStreamParserAdapter delegate methods

/** parser:foundObject: tests */

/**
 * Should not store anything given nil.
 */
- (void)testParserFoundObject_Nil_UnchangedAttributes;

/**
 * Should not notify the delegate given nil.
 */
- (void)testParserFoundObject_Nil_UnnotifiedDelegate;

/**
 * Should not store anything given an object with the wrong keys.
 */
- (void)testParserFoundObject_DifferentKeys_UnchangedAttributes;

/**
 * Should notify the delegate of the discovered ref.
 */
- (void)testParserFoundObject_Ref_NotifiedDelegate;

/**
 * Should store data correctly.
 */
- (void)testParserFoundObject_Repository_CorrectAttributes;

/**
 * Should overwrite the existing data with the data found in the object.
 */
- (void)testParserFoundObject_ExistingData_UpdatedAttributes;

/**
 * Should store NSNull data correctly.
 */
- (void)testParserFoundObject_RepositoryWithNSNullAttributes_CorrectAttributes;

@end
