#import "GHTreeLeafTests.h"

@implementation GHTreeLeafTests

- (void)setUp {
  leaf = [[GHTreeLeaf alloc] init];
}

- (void)tearDown {
  leaf = nil;
}

/** mode tests */

- (void)testMode_NSString {
  [leaf setValue:[NSString string] forKey:@"_mode"];
  STAssertTrue([[NSString string] isEqualToString:leaf.mode], @"should have stored mode string");
}

- (void)testSetMode_NoMethod {
  STAssertThrowsSpecificNamed([leaf performSelector:@selector(setMode:) withObject:[NSString string]],
                              NSException, NSInvalidArgumentException,
                              @"should have thrown invalid argument exception for setMode: selector");
}

/** path tests */

- (void)testPath_NSString {
  [leaf setValue:[NSString string] forKey:@"_path"];
  STAssertTrue([[NSString string] isEqualToString:leaf.path], @"should have stored path string");
}

- (void)testSetPath_NoMethod {
  STAssertThrowsSpecificNamed([leaf performSelector:@selector(setPath:) withObject:[NSString string]],
                              NSException, NSInvalidArgumentException,
                              @"should have thrown invalid argument exception for setPath: selector");
}

/** sha tests */

- (void)testSha_NSString {
  [leaf setValue:[NSString string] forKey:@"_sha"];
  STAssertTrue([[NSString string] isEqualToString:leaf.sha], @"should have stored sha string");
}

- (void)testSetSha_NoMethod {
  STAssertThrowsSpecificNamed([leaf performSelector:@selector(setSha:) withObject:[NSString string]],
                              NSException, NSInvalidArgumentException,
                              @"should have thrown invalid argument exception for setSha: selector");
}

/** size tests */

- (void)testSize_NSUInteger {
  [leaf setValue:[NSNumber numberWithInteger:1U] forKey:@"_size"];
  STAssertEquals(1U, leaf.size, @"should have stored size NSUInteger");
}

- (void)testSetSize_NoMethod {
  STAssertThrowsSpecificNamed([leaf performSelector:@selector(setSize:) withObject:[NSNumber numberWithInteger:1U]],
                              NSException, NSInvalidArgumentException,
                              @"should have thrown invalid argument exception for setSize: selector");
}

@end
