# Github Framework

Fetches data from the [Github API][githubapi]. This project is intended to
encompass the entire API eventually. For now, this is not ready for production
usage and should not be considered stable.

[githubapi]: http://developer.github.com/

## Current Status

The initial release is focused on discovering an appropriate API. It will
support immutable and mutable access to:

* [Git objects][gitobjects] (blobs, trees, commits, refs)
* [Repositories][repositories]
* [Users][users]

[gitobjects]: http://developer.github.com/v3/git/
[repositories]: http://developer.github.com/v3/repos/
[users]: http://developer.github.com/v3/users/

## Installation

1. Create a workspace and add Github.xcodeproj and your app's xcodeproj to it.
2. Link your app's binary with libGithub.a in your Build Phases.
3. Add "$(BUILT_PRODUCTS_DIR)" to your app's User Header Search Paths and make
   sure "Always Search User Paths" is YES.
4. Add "-ObjC" to "Other Linker Flags."
5. For code completion, drag the files in the Headers group from the Github
   project to your app's project tree.

Other methods yet to do - this doesn't build as a universal library yet. If
you really want to do it this way:

1. Open Github.xcodeproj.
2. Choose the correct target platform (simulator or OS).
3. Build.
4. Right-click "libGithub.a" under "Products" and choose "Show in Finder". Copy
   that file and the headers next to it to your project.
3. Add the copied headers' directory to the header search path
4. Add the copied library's directory to the library search path
5. Add "-ObjC -force_load /path/to/the/copied/library" to "Other Linker Flags".

## Documentation

Not yet.

## Sample Project

Not yet.

## Future

* universal library
* authenticated access
* mutable resources
* add other resources
